#include <EEPROM.h>

#include "UsbKeyboard.h"
#include "Morse.h"


Morse morse = Morse(&UsbKeyboard);

//#define COMMON_CATHODE
#define COMMON_ANODE

// Arduino pins for segments a-g
byte segmentPins[] = {7, 11, 12, 13, 5, 10, 6};
// Common cathose pins.
byte digitPins[] = {8, 9};

byte digits[2];
byte curDigit = 0;

// Hex definitions of each digit
byte hexDigits[] = {0x3f, 0x6, 0x5b, 0x4f, 0x66, 0x6d,
                    0x7d, 0x7, 0xf, 0x6f,
                    0x38, // A -> 'L'
                    0x40, // B -> '-'
                    0x3f, // C -> '0'
                    0x5e,
                    0x79,
                    0x71
                    };

byte wdigit;

void displayDigits() {
byte segment;

  segment = digits[curDigit];
  for (byte i = 0; i < 7 ; i++) {
#ifdef COMMON_CATHODE
    digitalWrite(segmentPins[i], segment&0x1);
#endif
#ifdef COMMON_ANODE
    digitalWrite(segmentPins[i], 1-segment&0x1);
#endif
    segment >>= 1;
  }
#ifdef COMMON_CATHODE
  digitalWrite(digitPins[0], HIGH);
  digitalWrite(digitPins[1], HIGH);
  digitalWrite(digitPins[curDigit], LOW);
#endif
#ifdef COMMON_ANODE
  digitalWrite(digitPins[0], LOW);
  digitalWrite(digitPins[1], LOW);
  digitalWrite(digitPins[curDigit], HIGH);
#endif
  delayMs(10);
  curDigit = 1 - curDigit;
}

void setup() {

  #if defined(__AVR_ATmega8__)
    TIMSK&=!(1<<TOIE0);
    //TIMSK|=(1<<TOV1);
# else
    TIMSK0&=!(1<<TOIE0);
    TIMSK1|=(1<<TOIE1);
#endif

  pinMode(digitPins[0], OUTPUT);
  pinMode(digitPins[1], OUTPUT);
  for (byte i = 0; i < 7 ; i++)
    pinMode(segmentPins[i], OUTPUT);
  
  wdigit = 0;
  digits[0] = 0x40;
  digits[1] = 0x40;
}


void delayMs(unsigned int ms) {
   /*
  */ 
  for (int i = 0; i < ms; i++) {
    delayMicroseconds(1000);
  }
  
}


void loop() {
byte code;
  UsbKeyboard.update();
  displayDigits();
  code = morse.poll();
  if (code) {
    digits[0] = hexDigits[code>>4];
    digits[1] = hexDigits[code&0xf];
  }
}
